module TresMaquinas (module TresMaquinas, module Rede, module ST) where

import Rede
import ST

-- Exemplo das trs mquinas

myF a = case a of {
          0 -> State (\p -> case p of { 0 -> 1 ; 6 -> 2 ; _ -> 0 }) (0,6) ;
          1 -> State (\p -> case p of { 1 -> 1 ; 6 -> 1 ; _ -> 0 }) (0,6) ;
          2 -> State (\p -> case p of { 2 -> 1 ; 6 -> 1 ; _ -> 0 }) (0,6) ;
          3 -> State (\p -> case p of { 3 -> 1 ; _ -> 0 })          (0,6) ;
          4 -> State (\p -> case p of { 4 -> 1 ; _ -> 0 })          (0,6) ;
          5 -> State (\p -> case p of { 5 -> 1 ; _ -> 0 })          (0,6) ;
          _ -> State (\_ -> 0) (0,6)
	          }

myB a = case a of {
          3 -> State (\p -> case p of { 0 -> 1 ; 6 -> 2 ; _ -> 0 }) (0,6) ;
          4 -> State (\p -> case p of { 1 -> 1 ; 6 -> 1 ; _ -> 0 }) (0,6) ;
          5 -> State (\p -> case p of { 2 -> 1 ; 6 -> 1 ; _ -> 0 }) (0,6) ;
          0 -> State (\p -> case p of { 3 -> 1 ; _ -> 0 })          (0,6) ;
          1 -> State (\p -> case p of { 4 -> 1 ; _ -> 0 })          (0,6) ;
          2 -> State (\p -> case p of { 5 -> 1 ; _ -> 0 })          (0,6) ;
          _ -> State (\_ -> 0) (0,6)
	          }
myTop = State (\p -> if p == 6 then 3 else 1) (0,6)

myNet :: Net Int Int
myNet = Net myF myB myTop [0..5]
 
inicio :: State Int
inicio =fromList [(0,1),(1,1),(2,1),(6,3)]

step      = transition myNet
steps     = path myNet
explosion = explode myNet


-- steps [[2,1],[4]] `on` inicio
-- map (posOn . snd) it

-- explosion `on` inicio
-- map (posOn . snd) it

-- step [1] >> explosion `on` inicio
-- map (posOn . snd) it

-- acessiveis myNet
-- map posOn it
