module ProdutorConsumidor (module ProdutorConsumidor, module Rede, module ST) where

import Rede
import ST

-- Exemplo do produtor-consumidor

-- Posies: 0 -> @produz , 1 -> @entrega , 2 -> vazio , 3 -> cheio , 4 -> @recebe , 5 -> @consome
-- Accoes : 0 -> produz , 1 -> entrega , 2 -> recebe , 3 -> consome
 

myF a = case a of {
          0 -> State (\p -> case p of { 0 -> 1 ; _ -> 0 })          (0,5) ;
          1 -> State (\p -> case p of { 1 -> 1 ; 2 -> 1 ; _ -> 0 }) (0,5) ;
          2 -> State (\p -> case p of { 3 -> 1 ; 4 -> 1 ; _ -> 0 }) (0,5) ;
          3 -> State (\p -> case p of { 5 -> 1 ; _ -> 0 })          (0,5) ;
          _ -> State (\_ -> 0)                                      (0,5)
	          }

myB a = case a of {
          0 -> State (\p -> case p of { 1 -> 1 ; _ -> 0 })          (0,5) ;
          1 -> State (\p -> case p of { 0 -> 1 ; 3 -> 1 ; _ -> 0 }) (0,5) ;
          2 -> State (\p -> case p of { 2 -> 1 ; 5 -> 1 ; _ -> 0 }) (0,5) ;
          3 -> State (\p -> case p of { 4 -> 1 ; _ -> 0 })          (0,5) ;
	  _ -> State (\_ -> 0)                                      (0,5)
	          }
myTop = State (\_ -> 1) (0,5)

myNet :: Net Int Int
myNet = Net myF myB myTop [0..3]
 
inicio :: State Int
inicio =fromList [(0,1),(2,1),(4,1)]

step      = transition myNet
steps     = path myNet
explosion = explode myNet


-- explosion `on` inicio
-- map (posOn . snd) it

-- step [0] >> explosion `on` inicio
-- map (posOn . snd) it

-- steps [[0],[1]] `on` inicio
-- map (posOn . snd) it

-- acessiveis myNet inicio
-- map posOn it
